from service.dialog_state_monitor import DialogStateMonitor
from service.dialog_policy import DialogPolicy
from service.natural_languag_understanding import NaturalLanguageUnderstanding
from service.natural_language_generation import NaturalLanguageGeneration

# initialize classes
nlu = NaturalLanguageUnderstanding() # NLU
monitor = DialogStateMonitor() # DSM
dialog_policy = DialogPolicy() # DP
language_generation = NaturalLanguageGeneration() # NLG

# Main loop
user_input = input("Możesz zacząć pisać.\n")
while True:
    # NLU
    frame = nlu.process_input(user_input)
    print(frame)

    # DSM
    monitor.append(frame)

    # DP
    print(dialog_policy.next_dialogue_act(monitor.get_all()).act)

    # NLG
    response = language_generation.respond_to_name_query("Jak masz na imię?")
    print(response)

    if frame.act == "bye":
        break
    
    user_input = input(">\n")






